<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;sha2-0.10.1&#x2F;src&#x2F;sha512&#x2F;soft.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>soft.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../storage.js"></script><script src="../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https:&#x2F;&#x2F;raw.githubusercontent.com&#x2F;RustCrypto&#x2F;media&#x2F;6ee8e381&#x2F;logo.svg"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../sha2/index.html'><div class='logo-container rust-logo'><img src='https:&#x2F;&#x2F;raw.githubusercontent.com&#x2F;RustCrypto&#x2F;media&#x2F;6ee8e381&#x2F;logo.svg' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::many_single_char_names</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::consts</span>::{<span class="ident">BLOCK_LEN</span>, <span class="ident">K64X2</span>};
<span class="kw">use</span> <span class="ident">core::convert::TryInto</span>;

<span class="kw">fn</span> <span class="ident">add</span>(<span class="ident">a</span>: [<span class="ident">u64</span>; <span class="number">2</span>], <span class="ident">b</span>: [<span class="ident">u64</span>; <span class="number">2</span>]) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">u64</span>; <span class="number">2</span>] {
    [<span class="ident">a</span>[<span class="number">0</span>].<span class="ident">wrapping_add</span>(<span class="ident">b</span>[<span class="number">0</span>]), <span class="ident">a</span>[<span class="number">1</span>].<span class="ident">wrapping_add</span>(<span class="ident">b</span>[<span class="number">1</span>])]
}

<span class="doccomment">/// Not an intrinsic, but works like an unaligned load.</span>
<span class="kw">fn</span> <span class="ident">sha512load</span>(<span class="ident">v0</span>: [<span class="ident">u64</span>; <span class="number">2</span>], <span class="ident">v1</span>: [<span class="ident">u64</span>; <span class="number">2</span>]) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">u64</span>; <span class="number">2</span>] {
    [<span class="ident">v1</span>[<span class="number">1</span>], <span class="ident">v0</span>[<span class="number">0</span>]]
}

<span class="doccomment">/// Performs 2 rounds of the SHA-512 message schedule update.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sha512_schedule_x2</span>(<span class="ident">v0</span>: [<span class="ident">u64</span>; <span class="number">2</span>], <span class="ident">v1</span>: [<span class="ident">u64</span>; <span class="number">2</span>], <span class="ident">v4to5</span>: [<span class="ident">u64</span>; <span class="number">2</span>], <span class="ident">v7</span>: [<span class="ident">u64</span>; <span class="number">2</span>]) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">u64</span>; <span class="number">2</span>] {
    <span class="comment">// sigma 0</span>
    <span class="kw">fn</span> <span class="ident">sigma0</span>(<span class="ident">x</span>: <span class="ident">u64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        ((<span class="ident">x</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">63</span>) <span class="op">|</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>)) <span class="op">^</span> ((<span class="ident">x</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">56</span>) <span class="op">|</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">8</span>)) <span class="op">^</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">7</span>)
    }

    <span class="comment">// sigma 1</span>
    <span class="kw">fn</span> <span class="ident">sigma1</span>(<span class="ident">x</span>: <span class="ident">u64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u64</span> {
        ((<span class="ident">x</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">45</span>) <span class="op">|</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">19</span>)) <span class="op">^</span> ((<span class="ident">x</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">3</span>) <span class="op">|</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">61</span>)) <span class="op">^</span> (<span class="ident">x</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">6</span>)
    }

    <span class="kw">let</span> [<span class="ident">w1</span>, <span class="ident">w0</span>] <span class="op">=</span> <span class="ident">v0</span>;
    <span class="kw">let</span> [<span class="kw">_</span>, <span class="ident">w2</span>] <span class="op">=</span> <span class="ident">v1</span>;
    <span class="kw">let</span> [<span class="ident">w10</span>, <span class="ident">w9</span>] <span class="op">=</span> <span class="ident">v4to5</span>;
    <span class="kw">let</span> [<span class="ident">w15</span>, <span class="ident">w14</span>] <span class="op">=</span> <span class="ident">v7</span>;

    <span class="kw">let</span> <span class="ident">w16</span> <span class="op">=</span> <span class="ident">sigma1</span>(<span class="ident">w14</span>)
        .<span class="ident">wrapping_add</span>(<span class="ident">w9</span>)
        .<span class="ident">wrapping_add</span>(<span class="ident">sigma0</span>(<span class="ident">w1</span>))
        .<span class="ident">wrapping_add</span>(<span class="ident">w0</span>);
    <span class="kw">let</span> <span class="ident">w17</span> <span class="op">=</span> <span class="ident">sigma1</span>(<span class="ident">w15</span>)
        .<span class="ident">wrapping_add</span>(<span class="ident">w10</span>)
        .<span class="ident">wrapping_add</span>(<span class="ident">sigma0</span>(<span class="ident">w2</span>))
        .<span class="ident">wrapping_add</span>(<span class="ident">w1</span>);

    [<span class="ident">w17</span>, <span class="ident">w16</span>]
}

<span class="doccomment">/// Performs one round of the SHA-512 message block digest.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sha512_digest_round</span>(
    <span class="ident">ae</span>: [<span class="ident">u64</span>; <span class="number">2</span>],
    <span class="ident">bf</span>: [<span class="ident">u64</span>; <span class="number">2</span>],
    <span class="ident">cg</span>: [<span class="ident">u64</span>; <span class="number">2</span>],
    <span class="ident">dh</span>: [<span class="ident">u64</span>; <span class="number">2</span>],
    <span class="ident">wk0</span>: <span class="ident">u64</span>,
) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">u64</span>; <span class="number">2</span>] {
    <span class="macro">macro_rules!</span> <span class="ident">big_sigma0</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">28</span>) <span class="op">^</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">34</span>) <span class="op">^</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">39</span>))
        };
    }
    <span class="macro">macro_rules!</span> <span class="ident">big_sigma1</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">14</span>) <span class="op">^</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">18</span>) <span class="op">^</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>.<span class="ident">rotate_right</span>(<span class="number">41</span>))
        };
    }
    <span class="macro">macro_rules!</span> <span class="ident">bool3ary_202</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span> <span class="op">^</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span> <span class="op">&amp;</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span> <span class="op">^</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span>))
        };
    } <span class="comment">// Choose, MD5F, SHA1C</span>
    <span class="macro">macro_rules!</span> <span class="ident">bool3ary_232</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span> <span class="op">&amp;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>) <span class="op">^</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span> <span class="op">&amp;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span>) <span class="op">^</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span> <span class="op">&amp;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">c</span>)
        };
    } <span class="comment">// Majority, SHA1M</span>

    <span class="kw">let</span> [<span class="ident">a0</span>, <span class="ident">e0</span>] <span class="op">=</span> <span class="ident">ae</span>;
    <span class="kw">let</span> [<span class="ident">b0</span>, <span class="ident">f0</span>] <span class="op">=</span> <span class="ident">bf</span>;
    <span class="kw">let</span> [<span class="ident">c0</span>, <span class="ident">g0</span>] <span class="op">=</span> <span class="ident">cg</span>;
    <span class="kw">let</span> [<span class="ident">d0</span>, <span class="ident">h0</span>] <span class="op">=</span> <span class="ident">dh</span>;

    <span class="comment">// a round</span>
    <span class="kw">let</span> <span class="ident">x0</span> <span class="op">=</span> <span class="macro">big_sigma1!</span>(<span class="ident">e0</span>)
        .<span class="ident">wrapping_add</span>(<span class="macro">bool3ary_202!</span>(<span class="ident">e0</span>, <span class="ident">f0</span>, <span class="ident">g0</span>))
        .<span class="ident">wrapping_add</span>(<span class="ident">wk0</span>)
        .<span class="ident">wrapping_add</span>(<span class="ident">h0</span>);
    <span class="kw">let</span> <span class="ident">y0</span> <span class="op">=</span> <span class="macro">big_sigma0!</span>(<span class="ident">a0</span>).<span class="ident">wrapping_add</span>(<span class="macro">bool3ary_232!</span>(<span class="ident">a0</span>, <span class="ident">b0</span>, <span class="ident">c0</span>));
    <span class="kw">let</span> (<span class="ident">a1</span>, <span class="kw">_</span>, <span class="kw">_</span>, <span class="kw">_</span>, <span class="ident">e1</span>, <span class="kw">_</span>, <span class="kw">_</span>, <span class="kw">_</span>) <span class="op">=</span> (
        <span class="ident">x0</span>.<span class="ident">wrapping_add</span>(<span class="ident">y0</span>),
        <span class="ident">a0</span>,
        <span class="ident">b0</span>,
        <span class="ident">c0</span>,
        <span class="ident">x0</span>.<span class="ident">wrapping_add</span>(<span class="ident">d0</span>),
        <span class="ident">e0</span>,
        <span class="ident">f0</span>,
        <span class="ident">g0</span>,
    );

    [<span class="ident">a1</span>, <span class="ident">e1</span>]
}

<span class="doccomment">/// Process a block with the SHA-512 algorithm.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sha512_digest_block_u64</span>(<span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u64</span>; <span class="number">8</span>], <span class="ident">block</span>: <span class="kw-2">&amp;</span>[<span class="ident">u64</span>; <span class="number">16</span>]) {
    <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">K64X2</span>;

    <span class="macro">macro_rules!</span> <span class="ident">schedule</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">v0</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v1</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v4</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v5</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v7</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="ident">sha512_schedule_x2</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">v0</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v1</span>, <span class="ident">sha512load</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">v4</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v5</span>), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">v7</span>)
        };
    }

    <span class="macro">macro_rules!</span> <span class="ident">rounds4</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">wk0</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">wk1</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {{
            <span class="kw">let</span> [<span class="ident">u</span>, <span class="ident">t</span>] <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">wk0</span>;
            <span class="kw">let</span> [<span class="ident">w</span>, <span class="ident">v</span>] <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">wk1</span>;

            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span> <span class="op">=</span> <span class="ident">sha512_digest_round</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span>, <span class="ident">t</span>);
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span> <span class="op">=</span> <span class="ident">sha512_digest_round</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span>, <span class="ident">u</span>);
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span> <span class="op">=</span> <span class="ident">sha512_digest_round</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span>, <span class="ident">v</span>);
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span> <span class="op">=</span> <span class="ident">sha512_digest_round</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">bf</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">cg</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dh</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ae</span>, <span class="ident">w</span>);
        }};
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ae</span> <span class="op">=</span> [<span class="ident">state</span>[<span class="number">0</span>], <span class="ident">state</span>[<span class="number">4</span>]];
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">bf</span> <span class="op">=</span> [<span class="ident">state</span>[<span class="number">1</span>], <span class="ident">state</span>[<span class="number">5</span>]];
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cg</span> <span class="op">=</span> [<span class="ident">state</span>[<span class="number">2</span>], <span class="ident">state</span>[<span class="number">6</span>]];
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">dh</span> <span class="op">=</span> [<span class="ident">state</span>[<span class="number">3</span>], <span class="ident">state</span>[<span class="number">7</span>]];

    <span class="comment">// Rounds 0..20</span>
    <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">w1</span>, <span class="kw-2">mut</span> <span class="ident">w0</span>) <span class="op">=</span> ([<span class="ident">block</span>[<span class="number">3</span>], <span class="ident">block</span>[<span class="number">2</span>]], [<span class="ident">block</span>[<span class="number">1</span>], <span class="ident">block</span>[<span class="number">0</span>]]);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">0</span>], <span class="ident">w0</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">1</span>], <span class="ident">w1</span>));
    <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">w3</span>, <span class="kw-2">mut</span> <span class="ident">w2</span>) <span class="op">=</span> ([<span class="ident">block</span>[<span class="number">7</span>], <span class="ident">block</span>[<span class="number">6</span>]], [<span class="ident">block</span>[<span class="number">5</span>], <span class="ident">block</span>[<span class="number">4</span>]]);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">2</span>], <span class="ident">w2</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">3</span>], <span class="ident">w3</span>));
    <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">w5</span>, <span class="kw-2">mut</span> <span class="ident">w4</span>) <span class="op">=</span> ([<span class="ident">block</span>[<span class="number">11</span>], <span class="ident">block</span>[<span class="number">10</span>]], [<span class="ident">block</span>[<span class="number">9</span>], <span class="ident">block</span>[<span class="number">8</span>]]);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">4</span>], <span class="ident">w4</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">5</span>], <span class="ident">w5</span>));
    <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">w7</span>, <span class="kw-2">mut</span> <span class="ident">w6</span>) <span class="op">=</span> ([<span class="ident">block</span>[<span class="number">15</span>], <span class="ident">block</span>[<span class="number">14</span>]], [<span class="ident">block</span>[<span class="number">13</span>], <span class="ident">block</span>[<span class="number">12</span>]]);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">6</span>], <span class="ident">w6</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">7</span>], <span class="ident">w7</span>));
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">w8</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w7</span>);
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">w9</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w8</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">8</span>], <span class="ident">w8</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">9</span>], <span class="ident">w9</span>));

    <span class="comment">// Rounds 20..40</span>
    <span class="ident">w0</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w9</span>);
    <span class="ident">w1</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w0</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">10</span>], <span class="ident">w0</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">11</span>], <span class="ident">w1</span>));
    <span class="ident">w2</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w1</span>);
    <span class="ident">w3</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w2</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">12</span>], <span class="ident">w2</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">13</span>], <span class="ident">w3</span>));
    <span class="ident">w4</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w3</span>);
    <span class="ident">w5</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w4</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">14</span>], <span class="ident">w4</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">15</span>], <span class="ident">w5</span>));
    <span class="ident">w6</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w5</span>);
    <span class="ident">w7</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w6</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">16</span>], <span class="ident">w6</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">17</span>], <span class="ident">w7</span>));
    <span class="ident">w8</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w7</span>);
    <span class="ident">w9</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w8</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">18</span>], <span class="ident">w8</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">19</span>], <span class="ident">w9</span>));

    <span class="comment">// Rounds 40..60</span>
    <span class="ident">w0</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w9</span>);
    <span class="ident">w1</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w0</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">20</span>], <span class="ident">w0</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">21</span>], <span class="ident">w1</span>));
    <span class="ident">w2</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w1</span>);
    <span class="ident">w3</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w2</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">22</span>], <span class="ident">w2</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">23</span>], <span class="ident">w3</span>));
    <span class="ident">w4</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w3</span>);
    <span class="ident">w5</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w4</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">24</span>], <span class="ident">w4</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">25</span>], <span class="ident">w5</span>));
    <span class="ident">w6</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w5</span>);
    <span class="ident">w7</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w6</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">26</span>], <span class="ident">w6</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">27</span>], <span class="ident">w7</span>));
    <span class="ident">w8</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w7</span>);
    <span class="ident">w9</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w8</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">28</span>], <span class="ident">w8</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">29</span>], <span class="ident">w9</span>));

    <span class="comment">// Rounds 60..80</span>
    <span class="ident">w0</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w9</span>);
    <span class="ident">w1</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w0</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">30</span>], <span class="ident">w0</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">31</span>], <span class="ident">w1</span>));
    <span class="ident">w2</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w1</span>);
    <span class="ident">w3</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w2</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">32</span>], <span class="ident">w2</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">33</span>], <span class="ident">w3</span>));
    <span class="ident">w4</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w6</span>, <span class="ident">w7</span>, <span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w3</span>);
    <span class="ident">w5</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w7</span>, <span class="ident">w8</span>, <span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w4</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">34</span>], <span class="ident">w4</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">35</span>], <span class="ident">w5</span>));
    <span class="ident">w6</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w8</span>, <span class="ident">w9</span>, <span class="ident">w2</span>, <span class="ident">w3</span>, <span class="ident">w5</span>);
    <span class="ident">w7</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w9</span>, <span class="ident">w0</span>, <span class="ident">w3</span>, <span class="ident">w4</span>, <span class="ident">w6</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">36</span>], <span class="ident">w6</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">37</span>], <span class="ident">w7</span>));
    <span class="ident">w8</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w0</span>, <span class="ident">w1</span>, <span class="ident">w4</span>, <span class="ident">w5</span>, <span class="ident">w7</span>);
    <span class="ident">w9</span> <span class="op">=</span> <span class="macro">schedule!</span>(<span class="ident">w1</span>, <span class="ident">w2</span>, <span class="ident">w5</span>, <span class="ident">w6</span>, <span class="ident">w8</span>);
    <span class="macro">rounds4!</span>(<span class="ident">ae</span>, <span class="ident">bf</span>, <span class="ident">cg</span>, <span class="ident">dh</span>, <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">38</span>], <span class="ident">w8</span>), <span class="ident">add</span>(<span class="ident">k</span>[<span class="number">39</span>], <span class="ident">w9</span>));

    <span class="kw">let</span> [<span class="ident">a</span>, <span class="ident">e</span>] <span class="op">=</span> <span class="ident">ae</span>;
    <span class="kw">let</span> [<span class="ident">b</span>, <span class="ident">f</span>] <span class="op">=</span> <span class="ident">bf</span>;
    <span class="kw">let</span> [<span class="ident">c</span>, <span class="ident">g</span>] <span class="op">=</span> <span class="ident">cg</span>;
    <span class="kw">let</span> [<span class="ident">d</span>, <span class="ident">h</span>] <span class="op">=</span> <span class="ident">dh</span>;

    <span class="ident">state</span>[<span class="number">0</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">0</span>].<span class="ident">wrapping_add</span>(<span class="ident">a</span>);
    <span class="ident">state</span>[<span class="number">1</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">1</span>].<span class="ident">wrapping_add</span>(<span class="ident">b</span>);
    <span class="ident">state</span>[<span class="number">2</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">2</span>].<span class="ident">wrapping_add</span>(<span class="ident">c</span>);
    <span class="ident">state</span>[<span class="number">3</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">3</span>].<span class="ident">wrapping_add</span>(<span class="ident">d</span>);
    <span class="ident">state</span>[<span class="number">4</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">4</span>].<span class="ident">wrapping_add</span>(<span class="ident">e</span>);
    <span class="ident">state</span>[<span class="number">5</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">5</span>].<span class="ident">wrapping_add</span>(<span class="ident">f</span>);
    <span class="ident">state</span>[<span class="number">6</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">6</span>].<span class="ident">wrapping_add</span>(<span class="ident">g</span>);
    <span class="ident">state</span>[<span class="number">7</span>] <span class="op">=</span> <span class="ident">state</span>[<span class="number">7</span>].<span class="ident">wrapping_add</span>(<span class="ident">h</span>);
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">compress</span>(<span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">u64</span>; <span class="number">8</span>], <span class="ident">blocks</span>: <span class="kw-2">&amp;</span>[[<span class="ident">u8</span>; <span class="number">128</span>]]) {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">block_u32</span> <span class="op">=</span> [<span class="number">0u64</span>; <span class="ident">BLOCK_LEN</span>];
    <span class="comment">// since LLVM can&#39;t properly use aliasing yet it will make</span>
    <span class="comment">// unnecessary state stores without this copy</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">state_cpy</span> <span class="op">=</span> <span class="kw-2">*</span><span class="ident">state</span>;
    <span class="kw">for</span> <span class="ident">block</span> <span class="kw">in</span> <span class="ident">blocks</span> {
        <span class="kw">for</span> (<span class="ident">o</span>, <span class="ident">chunk</span>) <span class="kw">in</span> <span class="ident">block_u32</span>.<span class="ident">iter_mut</span>().<span class="ident">zip</span>(<span class="ident">block</span>.<span class="ident">chunks_exact</span>(<span class="number">8</span>)) {
            <span class="kw-2">*</span><span class="ident">o</span> <span class="op">=</span> <span class="ident">u64::from_be_bytes</span>(<span class="ident">chunk</span>.<span class="ident">try_into</span>().<span class="ident">unwrap</span>());
        }
        <span class="ident">sha512_digest_block_u64</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">state_cpy</span>, <span class="kw-2">&amp;</span><span class="ident">block_u32</span>);
    }
    <span class="kw-2">*</span><span class="ident">state</span> <span class="op">=</span> <span class="ident">state_cpy</span>;
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="sha2" data-search-index-js="../../../search-index.js" data-search-js="../../../search.js"></div>
    <script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script>
</body></html>